
#ifndef _DVB_USB_CINERGYT2_H_
#define _DVB_USB_CINERGYT2_H_

#define DVB_USB_LOG_PREFIX "cinergyT2"
#define CONFIG_DVB_USB_DEBUG 1
#include "dvb-usb.h"

#define DRIVER_NAME "TerraTec/qanu USB2.0 Highspeed DVB-T Receiver"

extern int dvb_usb_cinergyt2_debug;
#define deb_info(args...) dprintk(dvb_usb_cinergyt2_debug,0x01,args)
#define deb_xfer(args...) dprintk(dvb_usb_cinergyt2_debug,0x02,args)
#define deb_rc(args...)   dprintk(dvb_usb_cinergyt2_debug,0x04,args)


enum cinergyt2_ep1_cmd {
	CINERGYT2_EP1_PID_TABLE_RESET		= 0x01,
	CINERGYT2_EP1_PID_SETUP			= 0x02,
	CINERGYT2_EP1_CONTROL_STREAM_TRANSFER	= 0x03,
	CINERGYT2_EP1_SET_TUNER_PARAMETERS	= 0x04,
	CINERGYT2_EP1_GET_TUNER_STATUS		= 0x05,
	CINERGYT2_EP1_START_SCAN		= 0x06,
	CINERGYT2_EP1_CONTINUE_SCAN		= 0x07,
	CINERGYT2_EP1_GET_RC_EVENTS		= 0x08,
	CINERGYT2_EP1_SLEEP_MODE		= 0x09,
	CINERGYT2_EP1_GET_FIRMWARE_VERSION	= 0x0A
};


struct dvbt_get_status_msg {
	uint32_t freq;
	uint8_t bandwidth;
	uint16_t tps;
	uint8_t flags;
	uint16_t gain;
	uint8_t snr;
	uint32_t viterbi_error_rate;
	uint32_t rs_error_rate;
	uint32_t uncorrected_block_count;
	uint8_t lock_bits;
	uint8_t prev_lock_bits;
} __attribute__((packed));


struct dvbt_set_parameters_msg {
	uint8_t cmd;
	uint32_t freq;
	uint8_t bandwidth;
	uint16_t tps;
	uint8_t flags;
} __attribute__((packed));


extern struct dvb_usb_rc_key cinergyt2_rc_keys[];
extern int cinergyt2_rc_keys_size(void);


extern struct dvb_frontend * cinergyt2_fe_attach(struct dvb_usb_device *d);
extern int cinergyt2_command(struct dvb_usb_device *d, char *send_buf, int send_buf_len, char *recv_buf, int recv_buf_len, int msec);
extern int cinergyt2_rc_query(struct dvb_usb_device *d, u32 *event, int *state);



#endif /* _DVB_USB_CINERGYT2_H_ */
